function hoek = detectlines(BW)
% dmv de radon functie worden de rechten gedetecteerd en vervolgens in
% volgorde van belangrijkheid opgeslagen.  De hoeken worden teruggegeven.


AANTAL_RECHTEN = 3;
theta = 0:179;
[R,xp] = radon(BW,theta);
% figure;
% imagesc(theta, xp, Stats.R); 
% colormap(hot);
% xlabel('\theta (degrees)'); ylabel('X\prime');
% title('R_{\theta} (X\prime)');
% colorbar

i = find(R>15);
[value, ind] = sort(-R(i));%sort is steeds in stijgende volgorde
k = i(ind(1:AANTAL_RECHTEN));

% k is de index in R (als 1Dim array) van de grootste waarden in R;
[y,x] = ind2sub(size(R),k);% van matrix-info naar assenstelsel!

% x is matrix grootheid en moet dus -1 om tot de hoekgrootte te komen
% voor de hoekorientatie kijk in de help files, maar matlab gebruikt ze tegengesteld
theta = (-x+1)*pi/180; 
% in se een herschaling van de matrix index y naar de geschaalde grootheid
% in de grafiek van de X' as
r = xp(y);

% De lijnen loodrecht op deze richtingen in offset r zijn de gezochte
% rechten

% =========================
% oorsprong zoeken van X'Y'
% =========================

[X,Y] = pol2cart(theta,r);

% H = get(stats,'children'); %als je dit commando uitvoert wordt opnieuw
% stats opgestart waardoor de inhoud van de axes wordt "gereset"!
h = findobj('type','axes','tag','DescriptionAxes');
axes(h);
set(h,'nextplot','add');

t = -200:200;
[rows cols] = size(BW)
for i = 1:AANTAL_RECHTEN
    plot(X(i)+(cols+1)/2+t*sin(theta(i)),Y(i)+(rows+1)/2-t*cos(theta(i)));
end
hoek = theta*180/pi;
