function P = mvnp(T,E)
% bepaalt de kans dat een datapunt met dimensie N boven of onder de threshold ligt,
% in een multi variante normaalverdeling met covariantiematrix volgens de
% Monte-Carlo methode. T is een dubbele kolommatrix, waarbij in de eerste
% kolom de grenzen worden aangegeven, en in de andere kolom de logische
% funtie, 1 is groter dan, -1 kleiner dan.

N = size(T,1)
Samples = 1000000;
X = randn(N, Samples);
C = chol(E);
X = (C'*X);

% alles omzetten naar groter dan voorwaarden
for i = 1:N
    if T(i,2) < 0 
        X(i,:) = -X(i,:);
        T(i,1) = -T(i,1);
    end
end

% de grenzen zetten voor iedere element van X
T = T(:,1);
T = T(:,ones(1,Samples));

% verificatie van grens en tellen
T = X > T;
if N > 1
    T = sum(T);
end;
P = sum(T==N)/Samples;