function P = mvnp2(T, CovData);
%uitbeiding van mvnp waarbij de threshold nu reeds in de gepaste vorm moet
%doorgegeven worden, waarbij -1 voor kleiner dan staat, 1 >, en 0 voor
%marginalisatie

SAMPLES = 6000000;
CovLength = size(CovData,1);

% data generatie voor de gepaste dimensie met gepaste covariantie
X = randn(CovLength, SAMPLES);
C = chol(CovData);
X = (C'*X);

% alles omzetten naar groter dan voorwaarden, en omzetten van de
% marginalisatie, door een zeer lage drempel
for i = 1:CovLength
    if T(i,2) < 0 
        X(i,:) = -X(i,:);
        T(i,1) = -T(i,1);
    end
    if T(i,2) == 0;
        T(i,1) = -100;
    end
end

% de grenzen zetten voor iedere element van X
T = T(:,1);
T = T(:,ones(1,floor(SAMPLES/2)));

% verificatie van grens en tellen
T2 = X(:,1:floor(SAMPLES/2)) > T;
if CovLength > 1
    T2 = sum(T2);
end;
P = sum(T2==CovLength); 

% verificatie van grens en tellen
T = X(:,floor(SAMPLES/2)+1:SAMPLES) > T;
if CovLength > 1
    T = sum(T);
end;
P = (P+sum(T==CovLength))/SAMPLES; 