function P = slpd(Threshold, CovData, Max)
%geeft de conditionele probabiliteiten terug, gebaseerde op de covariantie
%informatie.  Dus P(3) is de kans dat 3 zich voordoet als 2 en 1 voldaan
%zijn.  Als de threshold een scalair is wordt we op alle dimensies
%toegepast.

if ~exist('Max')
    Max = size(CovData,1);
end;

if size(CovData,1) > length(Threshold)
    Threshold = Threshold(ones(size(CovData,1),1));
end;

%berekenen van de gezamelijke propabiliteiten
P = zeros(1,Max);
for i = 1:size(CovData,1)
    P(i) = mvnp(Threshold(1:i)', CovData(1:i,1:i));
end;

Max = max(Max,size(CovData,1));
%omzetten naar de conditionele propabiliteiten met verderzetting

for i = 2:Max
    if P(i) ~= 0 
        P(i) = P(i)/P(i-1);
    else
        P(i) = P(i-1);
    end;
end;

%omzetten naar segmentlengtekans
for i = 1:Max-1
    P(i+1) = P(i+1)*P(i);  %fractie van segmenten met minimun lengte i
    P(i) = P(i)-P(i+1);    %P(i) is nu de fractie van segmenten met precies lengte i
end;
    
%normalizeren
% Som = sum(P);
% P = P/Som;

    