function P = slpd1(Threshold, CovData, Max)
%geeft de conditionele probabiliteiten terug, gebaseerde op de covariantie
%informatie.  Dus P(3) is de kans dat 3 zich voordoet als 2 en 1 voldaan
%zijn.  Als de threshold een scalair is wordt we op alle dimensies
%toegepast.
%Simpele theorie:  gemengde probabiliteit * aantal TP

CovLengte = size(CovData,1);
if ~exist('Max')
    Max = CovLengte + 1 ;
end;

Threshold = [Threshold 1]

%berekenen van de gezamelijke propabiliteiten
P = zeros(1,Max);
P(1) = mvnp(Threshold, CovData(1,1));
for i = 2:size(CovData,1)
    P(i) = mvnp(Threshold(ones(1,i),:), CovData(1:i,1:i));
end;

TPFractie = P(1);
%verderzetting van de kans
Factor = P(CovLengte)/P(CovLengte-1);
for i = CovLengte:Max
    P(i+1:Max) = P(i)*Factor;
end;


%omzetten naar segmentkansen, want in een 3Seg zit 2* een 2Seg
P = P./(1:100);

for i = Max:2
    for j = 1:i-1
        P(j) = P(j) - (i-j+1)*P(i);
    end
end
        
%normalizeren

P = P * TPFractie/((1:100)*P');


