function P = slpd2(Threshold, CovData, Max)
%zoekt de segmentkansen door voor en na het segment een niet straat pixel
%te beschouwen. Dus een 3Seg is -1,1,1,1,-1.

CovLengte = size(CovData,1);
if ~exist('Max')
    Max = CovLengte + 1 ;
end;

Threshold = [Threshold 1]

%berekenen van de gezamelijke propabiliteiten
P = zeros(1,Max);
TPFractie = mvnp(Threshold, CovData(1,1));

for i = 1:size(CovData,1)-2
    Threshold = Threshold(ones(1,i+2),:);
    Threshold(1,2) = -1;
    Threshold(i+2,2) = -1;
    P(i) = mvnp(Threshold(ones(1,i+2),:), CovData(1:i+2,1:i+2));
end;


%verderzetting van de kans
Factor = P(CovLengte-2)/P(CovLengte-3);
for i = CovLengte-2:Max
    P(i+1:Max) = P(i)*Factor;
end;


%normalizeren

P = P * TPFractie/((1:100)*P');


