function P = slpd3(Threshold, CovData, Max)
%gebaseerd op groeikans

CovLengte = size(CovData,1);
if ~exist('Max')
    Max = CovLengte + 1 ;
end;

Threshold = [Threshold 1]

%berekenen van de gezamelijke propabiliteiten
P = zeros(1,Max);
TPFractie = mvnp(Threshold, CovData(1,1));

for i = 2:size(CovData,1)-2
    Threshold = Threshold(ones(1,i+2),:);
    Threshold(1,2) = -1;
    Threshold(i+2,2) = -1;
    NGrow = mvnp(Threshold(ones(1,i+2),:), CovData(1:i+2,1:i+2));
    Threshold(i+2,2) = 1;
    Grow = mvnp(Threshold(ones(1,i+2),:), CovData(1:i+2,1:i+2));
    P(i) = Grow/(Grow+NGrow);
end;

%verderzetting van de groeikans
Factor = P(CovLengte-2)/P(CovLengte-3);
for i = CovLengte-2:Max
    P(i+1:Max) = P(i)*Factor;
end;

%overgaan op segment kans, want in 3Seg zit een 2Seg, en dus moet ieder
%3Seg van 2Seg afgetrokken worden
%vb. 3Seg = P(123-1234)
P(1) = TPFractie;
for i = 2:Max-1
    for j = i+1:Max
        P(j) = P(j)*P(i);
    end
end;
for i = 1:Max-1
    P(i) = P(i)-P(i+1);
end;

%normalizeren
P = P * TPFractie/((1:100)*P');


