function DistOfSegLengths = slpd4(Threshold, CovData)
% Monte Carlo generatie van segmenten

CovLengte = size(CovData,2);
if ~exist('Max')
    Max = CovLengte + 1 ;
end;
SEG1MAX = 1000;
SAMPLES = 10000;

% Creeren van de CovData
CovRij = CovData(CovLengte,:);
CovRij(CovLengte+1:2*CovLengte-1) = CovData(1,2:CovLengte);
CovData = 0;
CovData(1,1:SEG1MAX) = 1;
CovData = diag(CovData);
for i = 1:floor(CovLengte-1)
    Gem = (CovRij(CovLengte-i) + CovRij(CovLengte+i)) / 2;
    CovRij(CovLengte - i) = Gem;
    CovRij(CovLengte + i) = Gem;
end;
CovData = conv2(CovData,CovRij,'same');


% random data genereren
X = randn(SEG1MAX, SAMPLES);
C = chol(CovData);
X = (C'*X);
X = reshape(X,1,SEG1MAX*SAMPLES);
X = (X > Threshold);
X = bwlabeln(X,4);
MaxNoSeg = max(X);
DistOfSegLengths(100) = 0;
Lengte = 0;
for i = 1:SAMPLES*SEG1MAX
    if X(i)
        Lengte = Lengte + 1;
    else
        if Lengte ~= 0
            if Lengte > 100
                Lengte = 100;
            end
            DistOfSegLengths(Lengte) = DistOfSegLengths(Lengte) + 1;
        end
        Lengte = 0;
    end;
end;
DistOfSegLengths = DistOfSegLengths / (DistOfSegLengths*(1:100)');