function SegP = slpd5(Thres, CovData)
% segmentpropabiliteit gebaseerd op regel van bayes
% een segment wordt hier gedefineerd als een lengte van opeenvolgende
% straatpixels voorafgegaan en beeindigd met een niet-straatpixel

CovLength = size(CovData,1);
PBigCoef = bigseg(Thres, CovData);
PSmallCoef = smallseg(Thres, CovData);

% de segmenten binnen de halve covlength
for SegL = 1:(CovLength+1)/2
    P = 1;
    for i = 1:SegL-1
        P = P * PBigCoef(i,1);
    end
    for i = 2:SegL
        P = P / PBigCoef(i,2);
    end
    SegP(SegL) = P * PSmallCoef(SegL);
end

% segmenten groter dan halve covlength

P = PBigCoef(1,1);
for i = 2:(CovLength+1)/2
    P = P * PBigCoef(i,1) / PBigCoef(i,2);
end
PBkp = P;
for SegL = (CovLength+1)/2+1:102
    P = PBkp * (PBigCoef((CovLength+1)/2+1,1)/PBigCoef((CovLength+1)/2+1,2))^(SegL-(CovLength+1)/2-1);
    SegP(SegL) = P * PBigCoef((CovLength+1)/2+2,1) / PBigCoef((CovLength+1)/2+2,2);
end;
SegP = SegP(3:102);%segment wordt nu aaneenschakeling van enkel straatpixels