function P = smallseg(Thres, CovData)
%regel van bayes
%P(i,1) geven de noemers van de gezamelijke probabiliteiten
%P(i,2) geven de tellers van de gezamelijke probabiliteiten
%enkel de noemers van sluitingsfactoren worden berekend, daar de andere opening en
%groeifactoren dezelfde zijn als berekend in bigsegment

SAMPLES = 2000000;
CovLength = size(CovData,1);

% data generatie voor de gepaste dimensie met gepaste covariantie
X = randn(CovLength, SAMPLES);
C = chol(CovData);
X = (C'*X);


for SegL = 3:(CovLength+1)/2
    Threshold = [Thres 1];
    Threshold = Threshold(ones(1,CovLength),:);
    Threshold(:,2) = 0;
    Threshold((CovLength+1)/2,2) = -1;
    Threshold((CovLength+1)/2+1:(CovLength+1)/2+SegL-2,2) = 1;
    Threshold((CovLength+1)/2+SegL-1,2) = -1;
    T = Threshold;
    % alles omzetten naar groter dan voorwaarden, en omzetten van de
    % marginalisatie, door een zeer lage drempel
    for i = 1:CovLength
        if T(i,2) < 0 
            X(i,:) = -X(i,:);
            T(i,1) = -T(i,1);
        end
        if T(i,2) == 0;
            T(i,1) = -100;
        end
    end
    
    % de grenzen zetten voor iedere element van X
    T = T(:,1);
    T = T(:,ones(1,SAMPLES));
    
    % verificatie van grens en tellen
    T = X > T;
    if CovLength > 1
        T = sum(T);
    end;
    P(SegL) = sum(T==CovLength)/SAMPLES; 
    
    % data restaureren
    for i = 1:CovLength
        if Threshold(i,2) < 0 
            X(i,:) = -X(i,:);
        end
    end
end