function varargout = stats(varargin)
% STATS M-file for stats.fig
%      STATS, by itself, creates a new STATS or raises the existing
%      singleton*.
%
%      H = STATS returns the handle to a new STATS or the handle to
%      the existing singleton*.
%
%      STATS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in STATS.M with the given input arguments.
%
%      STATS('Property','Value',...) creates a new STATS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before stats_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to stats_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help stats

% Last Modified by GUIDE v2.5 19-Feb-2004 18:16:38

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @stats_OpeningFcn, ...
                   'gui_OutputFcn',  @stats_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before stats is made visible.
function stats_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to stats (see VARARGIN)

% Choose default command line output for stats
handles.output = hObject;
global Stats;

% =============================
% Colormap instellen voor Stats
% =============================
Stats.C.N = 2000;
Stats.C.Data = gray(Stats.C.N);
for i = 1:Stats.C.N
    Stats.C.Data(Stats.C.N+i,:) = [0.2+0.8*(i-1)/Stats.C.N 0 0];%rood
    Stats.C.Data(2*Stats.C.N+i,:) = [0 0.2+0.8*(i-1)/Stats.C.N 0];%groen
    Stats.C.Data(3*Stats.C.N+i,:) = [0 0 0.2+0.8*(i-1)/Stats.C.N];%blauw
end
colormap(Stats.C.Data);

axes(handles.DescriptionAxes);
image;
ShowMapPushbutton_Callback(handles.ShowMapPushbutton, eventdata, handles)
set(gca,'nextplot','replacechildren','YDir','reverse');

axes(handles.DetectionAxes);
set(gca,'nextplot','replacechildren','YDir','reverse');
drawdata(Stats.Global.Detection.Thin&Stats.Global.Description.Road,Stats.C.N);
fit;

% H = findobj(4,'type','axes');
% for i = 1:length(H)
%     replaceobj(handles.DetectionOutput,H(i));
% end
% 
% H = findobj(1,'type','axes');
% replaceobj(handles.axes4,H);


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes stats wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = stats_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in ShowRoadPushbutton.
function ShowRoadPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ShowRoadPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats
addim(Stats.Global.Description.Thin*Stats.C.N*2);


% --------------------------------------------------------------------
function ContextMenu_Callback(hObject, eventdata, handles)
% hObject    handle to ContextMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Undock_Callback(hObject, eventdata, handles)
% hObject    handle to Undock (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
h1 = gcf;
h2 = gca;
figure;
g1 = gcf;
g2 = copyobj(h2,g1);
set(g1, 'colormap', get(h1, 'colormap'));
set(g2, 'units','normalized','position', [0 0 1 1]);


% --------------------------------------------------------------------
function Zoom_Callback(hObject, eventdata, handles)
% hObject    handle to Zoom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
h = uicontrol(stats);
set(h, 'TooltipString','Exit Zoommode',...
       'Style','pushbutton',...
       'Tag','ExitZoom_PushButton',...
       'visible','on',...
       'Callback','stats(''ExitZoom_Callback'',gcbo,[],guihandles(gcf))',...
       'Units','normalized',...
       'Position',[0.3 0.975 0.02 0.02]);
zoom on;

function ExitZoom_Callback(hObject, eventdata, handles)
zoom off;
delete(hObject);


% --- Executes on button press in ShowNoisePushbutton.
function ShowNoisePushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ShowNoisePushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats
addim(Stats.Global.Detection.Mask * Stats.C.N + (Stats.Global.Description.Noise & Stats.Global.Detection.Mask) * 3 * Stats.C.N + ...
    (Stats.Global.Description.Road & ~Stats.Global.Detection.Mask) * 3 * (Stats.C.N*9/10));

% --- Executes on button press in DetectLinesPushbutton.
function DetectLinesPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to DetectLinesPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
detectlines;


% --- Executes on button press in SetRegionPushbutton.
function SetRegionPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to SetRegionPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats

[X,Y,C] = improfile;
Fin = length(X);
Stats.X1 = X(1);
Stats.X2 = X(Fin);
Stats.Y1 = Y(1);
Stats.Y2 = Y(Fin);

Stats.Local.Detection.OverviewMask = Stats.Global.Detection.OverviewMask(Stats.Y1:Stats.Y2,Stats.X1:Stats.X2);
Stats.Local.Detection.GrayHessMask = Stats.Global.Detection.GrayHessMask(Stats.Y1:Stats.Y2,Stats.X1:Stats.X2);
Stats.Local.Description.Deriv = Stats.Global.Description.Deriv(Stats.Y1:Stats.Y2,Stats.X1:Stats.X2,:);
Stats.Local.Description.Thin = Stats.Global.Description.Thin(Stats.Y1:Stats.Y2,Stats.X1:Stats.X2);
set(gca,'nextplot','replacechildren');
image(Stats.Local.Description.Thin*Stats.C.N);fit;

Theta = detectlines(Stats.Local.Description.Thin);
pause(1);

Stats.Local.Description.Thin = imrotate(Stats.Local.Description.Thin,Theta(1),'bilinear','crop');
Stats.Local.Description.Image = imrotate(Stats.Global.Description.Image(Stats.Y1:Stats.Y2,Stats.X1:Stats.X2),Theta(1),'bilinear','crop');
Stats.Local.Description.Road = imrotate(Stats.Global.Description.Road(Stats.Y1:Stats.Y2,Stats.X1:Stats.X2),Theta(1),'bilinear','crop');
Stats.Local.Description.Deriv(:,:,1) = imrotate(Stats.Local.Description.Deriv(:,:,1),Theta(1),'bilinear','crop');
Stats.Local.Description.Deriv(:,:,2) = imrotate(Stats.Local.Description.Deriv(:,:,2),Theta(1),'bilinear','crop');
Stats.Local.Description.Deriv(:,:,3) = imrotate(Stats.Local.Description.Deriv(:,:,3),Theta(1),'bilinear','crop');
Stats.Local.Description.Deriv(:,:,4) = imrotate(Stats.Local.Description.Deriv(:,:,4),Theta(1),'bilinear','crop');
Stats.Local.Description.Deriv(:,:,5) = imrotate(Stats.Local.Description.Deriv(:,:,5),Theta(1),'bilinear','crop');

Stats.Local.Detection.OverviewMask = imrotate(Stats.Local.Detection.OverviewMask,Theta(1),'bilinear','crop');
Stats.Local.Detection.GrayHessMask = imrotate(Stats.Local.Detection.GrayHessMask,Theta(1),'bilinear','crop');


image(Stats.Local.Description.Thin*Stats.C.N);fit;
L = locatemax(Stats.Local.Description.Image);
Stretch = Stats.C.N / Stats.Local.Description.Image(L(1),L(2));
image(Stats.Local.Description.Image*Stretch+(Stats.Local.Description.Thin)*Stats.C.N);


% --- Executes on button press in DetectionStatsPushbutton.
function DetectionStatsPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to DetectionStatsPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats

% ==================
% calculate segments
% ==================
Stats.Global.Detection.Mask = Stats.Global.Detection.OverviewMask & Stats.Global.Description.Thin;
Stats.Global.Detection.Mask = bwlabeln(Stats.Global.Detection.Mask,8); %meestal sneller dan bwlabel!
L = locatemax(Stats.Global.Detection.Mask);
Stats.Global.Detection.NumOfSeg = Stats.Global.Detection.Mask(L(1), L(2));

% =======================================================
% calculate average segmentlength and length distribution
% =======================================================
Stats.Global.Detection.DistOfSegLengths = 0;
for Seg = 1:Stats.Global.Detection.NumOfSeg
    Lengte = sum(sum(Stats.Global.Detection.Mask == Seg));
        if length(Stats.Global.Detection.DistOfSegLengths) < Lengte
            Stats.Global.Detection.DistOfSegLengths(Lengte) =  1;
        else
            Stats.Global.Detection.DistOfSegLengths(Lengte) = Stats.Global.Detection.DistOfSegLengths(Lengte) + 1;
        end;
end
MaxLength = length(Stats.Global.Detection.DistOfSegLengths);%overload
LengthVec = 1:MaxLength;
Stats.Global.Detection.AvgOfSegLengths = Stats.Global.Detection.DistOfSegLengths * LengthVec' / sum(Stats.Global.Detection.DistOfSegLengths);
TP = sum(sum(Stats.Global.Detection.Mask ~= 0)); % true positives
Stats.Global.FN = sum(sum(Stats.Global.Description.Thin)) - TP; %%%%%!!!!!!!!RANDEN ZIJN MEEGEREKEND!!!!!!%%%%%%%%%
Stats.Global.TP =  TP;

% ==================================================
% de gemeten distributie van de grootste eigenwaarde
% ==================================================
% randen mogen niet mee in de statistiek verwerkt worden
ThinShrink = Stats.Global.Description.Thin;
ThinShrink(1:2*Stats.Global.Description.CovSize+1,:) = 0;
ThinShrink(:,1:2*Stats.Global.Description.CovSize+1) = 0;
ThinShrink(size(ThinShrink,1)-2*Stats.Global.Description.CovSize:size(ThinShrink,1),:) = 0;
ThinShrink(:,size(ThinShrink,2)-2*Stats.Global.Description.CovSize:size(ThinShrink,2)) = 0;
EigData = Stats.Global.Detection.GrayHessMask(ThinShrink);



% =====================
% print info to display
% =====================
figure(statsreport);
H = guihandles(gcf);
set(H.DetectionStats, 'TooltipString','Statistics',...
       'Style','text',...
       'visible','on',...
       'Units','normalized',...
       'BackGroundColor',[0.38 0.47 0.70]);
%om text af te drukken met enters tussen wordt het onderverdeeld in
%verschillende delen van een cell-structuur
StatsText{1} = ['#Seg: ',num2str(Stats.Global.Detection.NumOfSeg)];
StatsText{2} = ['FN: ',num2str(Stats.Global.FN)];
StatsText{3} = ['TP: ',num2str(Stats.Global.TP)];
StatsText{4} = ['<SegLengte>: ',num2str(Stats.Global.Detection.AvgOfSegLengths)];
set(H.DetectionStats,'string',StatsText);

axes(H.Axes2);
set(gca,'nextplot','add');
bar(Stats.Global.Detection.DistOfSegLengths);

axes(H.Axes1);   
segcomb(Stats.Global.FN + Stats.Global.TP, Stats.Global.FN);
axes(H.Axes3);
hist(EigData, 100);
set(H.VarText,'String',num2str(std(EigData)));
colormap(Stats.C.Data);


% --- Executes on button press in CovPushbutton.
function CovPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to CovPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats
% ===========================================================
% Opstellen van de covariantie matrix en de gemiddelde matrix
% ===========================================================
CovData = gathercov(Stats.Global.Description.Image,Stats.Global.Description.Thin,Stats.Global.Description.CovSize);
Stats.Global.Description.Mean = reshape(mean(CovData), 2*Stats.Global.Description.CovSize+1, 2*Stats.Global.Description.CovSize+1)';
axes(handles.MeanAxes);
image(makeimage(Stats.Global.Description.Mean, Stats.C.N));

Stats.Global.Description.Cov = cov(CovData);
axes(handles.CovAxes);
image(makeimage(Stats.Global.Description.Cov, Stats.C.N));
set(gca,'YDir','reverse');fit;
%axis(gca,'off');

% ==================================
% Opstellen van de covariantielengte
% ==================================
[Rows Cols] = size(Stats.Global.Description.Cov);
Stats.Global.Description.CovLength = (reshape(Stats.Global.Description.Cov(:,floor(((Stats.Global.Description.CovSize*2+1)^2+1)/2)),...
            Stats.Global.Description.CovSize*2+1,Stats.Global.Description.CovSize*2+1))';
axes(handles.CovLengthAxes);
image(makeimage(Stats.Global.Description.CovLength, Stats.C.N));
set(gca,'YDir','reverse');fit;
%axis(gca,'off');

% ==================================
% Opstellen van de correlatie matrix
% ==================================
D = diag(Stats.Global.Description.Cov).^(1/2);
Stats.Global.Description.Corr = Stats.Global.Description.Cov ./ (D * D');
axes(handles.CorrAxes);
image(makeimage(Stats.Global.Description.Corr, Stats.C.N));
set(gca,'YDir','reverse');fit;
%axis(gca,'off');

% =================================
% Opstellen van de correlatielengte
% =================================
% 2*CovSize + 1 is de venstergrootte
[Rows Cols] = size(Stats.Global.Description.Corr);
Stats.Global.Description.CorrLength = (reshape(Stats.Global.Description.Corr(:,floor(((Stats.Global.Description.CovSize*2+1)^2+1)/2)),...
            Stats.Global.Description.CovSize*2+1,Stats.Global.Description.CovSize*2+1))';
axes(handles.CorrLengthAxes);
image(makeimage(Stats.Global.Description.CorrLength, Stats.C.N));
set(gca,'YDir','reverse');fit;
%axis(gca,'off');

% --- Executes on button press in AnalysePushbutton.
function AnalysePushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to AnalysePushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats Scene

%straatmodellering
[TP_Det, TP_Des, Segavg_Det, Segavg_Des, NumOfSeg] = getstats_inchess;

%ruismodellering
Shift = Stats.Global.Description.CovSize*2+1;
Stats.Global.Description.Thin = circshift(Stats.Global.Description.Thin,[0 Shift]);
[TP2_Det, TP2_Des, Segavg2_Det,Segavg2_Des, NumOfSeg2] = getstats_inchess;
Stats.Global.Description.Thin = circshift(Stats.Global.Description.Thin,[0 -Shift]);


% ======
% output
% ======
figure;
plot(TP_Det,'color',[0 0 1]);
set(gca,'nextplot','add');
plot(TP_Des,'color',[1 0 0]);

figure;
plot(Segavg_Det,'color',[0 0 1]);
set(gca,'nextplot','add');
plot(Segavg_Des,'color',[1 0 0.5]);
plot(NumOfSeg,'color',[0 1 0]);

figure;
plot(TP2_Det,'color',[0 0 1]);
set(gca,'nextplot','add');
plot(TP2_Des,'color',[1 0 0]);

figure;
plot(Segavg2_Det,'color',[0 0 1]);
set(gca,'nextplot','add');
plot(Segavg2_Des,'color',[1 0 0.5]);
plot(NumOfSeg2,'color',[0 1 0]);

% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in ShowMapPushbutton.
function ShowMapPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ShowMapPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats;
L = locatemax(Stats.Global.Description.Image);
Stretch = Stats.C.N / Stats.Global.Description.Image(L(1),L(2));
addim(Stats.Global.Description.Image*Stretch);

% --- Executes on button press in ResetPushbutton.
function ResetPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ResetPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
H = get(gca,'children');
for i = 1:length(H);
    delete(H(i));
end;


% --- Executes on button press in LocalCovPushbutton.
function LocalCovPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to LocalCovPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats
% ===================================
% Opstellen van de covariantie matrix
% ===================================
Stats.Local.Description.Cov = cov(gathercov(Stats.Local.Description.Image,Stats.Local.Description.Thin,Stats.Local.Description.CovSize));
A = locatemax(Stats.Local.Description.Cov);
axes(handles.LocalCovAxes);
image(Stats.Local.Description.Cov/Stats.Local.Description.Cov(A(1),A(2))*Stats.C.N);
set(gca,'YDir','reverse');fit;
axis(gca,'off');

% ==================================
% Opstellen van de covariantielengte
% ==================================
[Rows Cols] = size(Stats.Local.Description.Cov);
Stats.Local.Description.CovLength = (reshape(Stats.Local.Description.Cov(:,floor(((Stats.Local.Description.CovSize*2+1)^2+1)/2)),...
            Stats.Local.Description.CovSize*2+1,Stats.Local.Description.CovSize*2+1))';
A = locatemax(Stats.Local.Description.CovLength);
axes(handles.LocalCovLengthAxes);
image(Stats.Local.Description.CovLength/Stats.Local.Description.CovLength(A(1),A(2))*Stats.C.N);
set(gca,'YDir','reverse');fit;
axis(gca,'off');

% ==================================
% Opstellen van de correlatie matrix
% ==================================
D = diag(Stats.Local.Description.Cov).^(1/2);
Stats.Local.Description.Corr = Stats.Local.Description.Cov ./ (D * D');
A = locatemax(Stats.Local.Description.Corr);
axes(handles.LocalCorrAxes);
image(Stats.Local.Description.Corr/Stats.Local.Description.Corr(A(1),A(2))*Stats.C.N);
set(gca,'YDir','reverse');fit;
axis(gca,'off');

% =================================
% Opstellen van de correlatielengte
% =================================
[Rows Cols] = size(Stats.Local.Description.Corr);
Stats.Local.Description.CorrLength = (reshape(Stats.Local.Description.Corr(:,floor(((Stats.Local.Description.CovSize*2+1)^2+1)/2)),...
            Stats.Local.Description.CovSize*2+1,Stats.Local.Description.CovSize*2+1))';
A = locatemax(Stats.Local.Description.CorrLength);
axes(handles.LocalCorrLengthAxes);
image(Stats.Local.Description.CorrLength/Stats.Local.Description.CorrLength(A(1),A(2))*Stats.C.N);
set(gca,'YDir','reverse');fit;
axis(gca,'off');

% --- Executes on button press in ViewRegionPushbutton.
function ViewRegionPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ViewRegionPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats
L = locatemax(Stats.Local.Description.Image);
Stretch = Stats.C.N / Stats.Local.Description.Image(L(1),L(2));
addim(Stats.Local.Description.Image*Stretch);


% --- Executes on button press in LocalCovLengthPushbutton.
function LocalCovLengthPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to LocalCovLengthPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats
[Rows Cols] = size(Stats.Local.Description.Cov);
Stats.Local.Description.CovLength = (reshape(Stats.Local.Description.Cov(:,uint8(((Stats.Local.Description.CovSize*2+1)^2+1)/2)),...
            Stats.Local.Description.CovSize*2+1,Stats.Local.Description.CovSize*2+1))';
A = locatemax(Stats.Local.Description.CovLength);
axes(handles.LocalCovAxes);
image(Stats.Local.Description.CovLength/Stats.Local.Description.CovLength(A(1),A(2))*Stats.C.N);
set(handles.LocalCovAxes,'YDir','reverse');fit;


% --- Executes on button press in DescriptionLocStatsPushbutton.
function DescriptionLocStatsPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to DescriptionLocStatsPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats
stats('DetectionLocStatsPushbutton_Callback',hObject,[], handles);
% ======================================================
% randen mogen niet mee in de statistiek verwerkt worden
% ======================================================
ThinShrink = Stats.Local.Description.Thin;
ThinShrink(1:2*Stats.Local.Description.CovSize+1,:) = 0;
ThinShrink(:,1:2*Stats.Local.Description.CovSize+1) = 0;
ThinShrink(size(ThinShrink,1)-2*Stats.Local.Description.CovSize:size(ThinShrink,1),:) = 0;
ThinShrink(:,size(ThinShrink,2)-2*Stats.Local.Description.CovSize:size(ThinShrink,2)) = 0;
% ===================
% getallen extraheren
% ===================
DataYY = Stats.Local.Description.Deriv(:,:,3);
DataYY = DataYY(ThinShrink == 1);
DataXY = Stats.Local.Description.Deriv(:,:,4);
DataXY = DataXY(ThinShrink == 1);
DataXX = Stats.Local.Description.Deriv(:,:,5);
DataXX = DataXX(ThinShrink == 1);
Data = [DataXX DataXY DataYY];
% ========================
% statistiek Rxx, Rxy, Ryy
% ========================
MeanData = mean(Data);
CovData = cov(Data);
SData = (diag(CovData)).^(1/2);
CorrData = CovData ./ (SData*SData');


% ======
% output
% ======
figure(statsreport);
H = guihandles(gcf);
axes(H.XXAxes);
hist(DataXX,100);
set(H.XXText,'string',num2str(sqrt(CovData(1,1))));

axes(H.XYAxes);
hist(DataXY,100);
set(H.XYText,'string',num2str(sqrt(CovData(2,2))));

axes(H.YYAxes);
hist(DataYY,100);
set(H.YYText,'string',num2str(sqrt(CovData(3,3))));

axes(H.CovAxes);
image(makeimage(CovData,Stats.C.N));
axes(H.CorrAxes);
image((CorrData+1)*Stats.C.N/2);%1 moet wit zijn, -1 zwart, nuttig omdat corr genormaliseerd is
colormap(Stats.C.Data);



% ====================================================================================
% Opstellen van de covariantie matrix van Rxx in een venster w en de gemiddelde matrix
% ====================================================================================
CovData = gathercov(Stats.Local.Description.Deriv(:,:,5),Stats.Local.Description.Thin,Stats.Local.Description.CovSize);
Stats.Local.Description.RMean = reshape(mean(CovData), 2*Stats.Local.Description.CovSize+1, 2*Stats.Local.Description.CovSize+1)';
axes(H.RMeanAxes);
image(makeimage(Stats.Local.Description.RMean, Stats.C.N));

Stats.Local.Description.RCov = cov(CovData);
axes(H.RCovAxes);
image(makeimage(Stats.Local.Description.RCov, Stats.C.N));
set(gca,'YDir','reverse');fit;
axis(gca,'off');
% ==================================
% Opstellen van de covariantielengte
% ==================================
[Rows Cols] = size(Stats.Local.Description.RCov);
Stats.Local.Description.RCovLength = (reshape(Stats.Local.Description.RCov(:,floor(((Stats.Local.Description.CovSize*2+1)^2+1)/2)),...
            Stats.Local.Description.CovSize*2+1,Stats.Local.Description.CovSize*2+1))';
axes(H.RCovLengthAxes);
image(makeimage(Stats.Local.Description.RCovLength, Stats.C.N));
set(gca,'YDir','reverse');fit;
axis(gca,'off');
% ==================================
% Opstellen van de correlatie matrix
% ==================================
D = diag(Stats.Local.Description.RCov).^(1/2);
Stats.Local.Description.RCorr = Stats.Local.Description.RCov ./ (D * D');
axes(H.RCorrAxes);
image(makeimage(Stats.Local.Description.RCorr, Stats.C.N));
set(gca,'YDir','reverse');fit;
axis(gca,'off');
% =================================
% Opstellen van de correlatielengte
% =================================
% 2*CovSize + 1 is de venstergrootte
[Rows Cols] = size(Stats.Local.Description.RCorr);
Stats.Local.Description.RCorrLength = (reshape(Stats.Local.Description.RCorr(:,floor(((Stats.Local.Description.CovSize*2+1)^2+1)/2)),...
            Stats.Local.Description.CovSize*2+1,Stats.Local.Description.CovSize*2+1))';
axes(H.RCorrLengthAxes);
image(makeimage(Stats.Local.Description.RCorrLength, Stats.C.N));
set(gca,'YDir','reverse');fit;
axis(gca,'off');

% ===================================================================
% Opstellen van de covariantieinformatie nodig voor de segmentanalyse
% ===================================================================
Stats.Local.Description.SegRCov = Stats.Local.Description.RCov(Stats.Local.Description.CovSize+1:Stats.Local.Description.CovSize*2+1:(Stats.Local.Description.CovSize*2+1)^2,...
                                                                 Stats.Local.Description.CovSize+1:Stats.Local.Description.CovSize*2+1:(Stats.Local.Description.CovSize*2+1)^2);
axes(H.RMeanAxes);%OPGELET, info in dezelfde assen geplot!!!
image(makeimage(Stats.Local.Description.SegRCov, Stats.C.N)); 

% ==================
% Segmentmodellering
% ==================
Stats.Local.Description.P = mvnp([Stats.Local.Detection.Threshold - MeanData(1,1) 1], Stats.Local.Description.SegRCov(1));
Stats.Local.Description.SLPD = slpd6(Stats.Local.Detection.Threshold - MeanData(1,1), Stats.Local.Description.SegRCov);


% =======
% Output2
% =======
set(H.DescriptionText, 'TooltipString','Statistics',...
       'Style','text',...
       'visible','on',...
       'Units','normalized',...
       'BackGroundColor',[0.38 0.47 0.70]);
%om text af te drukken met enters tussen wordt het onderverdeeld in
%verschillende delen van een cell-structuur
StatsText{1} = ['P: ',num2str(Stats.Local.Description.P)];
StatsText{2} = ['TP: ',num2str((Stats.Local.FN+Stats.Local.TP)*Stats.Local.Description.P)];
StatsText{4} = ['<SegLengte>: ',num2str(Stats.Local.Description.SLPD*(1:length(Stats.Local.Description.SLPD))'/sum(Stats.Local.Description.SLPD))];
set(H.DescriptionText,'string',StatsText);

axes(H.Axes2)
set(gca,'Nextplot','add');

L = locatemax(Stats.Local.Description.SLPD);
plot(Stats.Local.Description.SLPD(1:length(Stats.Local.Description.SLPD)) / Stats.Local.Description.SLPD(L(1),L(2)));


% --- Executes on button press in DescriptionStatsPushbutton.
function DescriptionStatsPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to DescriptionStatsPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats
stats('DetectionStatsPushbutton_Callback',hObject,[], handles);
% ======================================================
% randen mogen niet mee in de statistiek verwerkt worden
% ======================================================
ThinShrink = Stats.Global.Description.Thin;
ThinShrink(1:2*Stats.Global.Description.CovSize+1,:) = 0;
ThinShrink(:,1:2*Stats.Global.Description.CovSize+1) = 0;
ThinShrink(size(ThinShrink,1)-2*Stats.Global.Description.CovSize:size(ThinShrink,1),:) = 0;
ThinShrink(:,size(ThinShrink,2)-2*Stats.Global.Description.CovSize:size(ThinShrink,2)) = 0;
% ===================
% getallen extraheren
% ===================
DataYY = Stats.Global.Description.Deriv(:,:,3);
DataYY = DataYY(ThinShrink == 1);
DataXY = Stats.Global.Description.Deriv(:,:,4);
DataXY = DataXY(ThinShrink == 1);
DataXX = Stats.Global.Description.Deriv(:,:,5);
DataXX = DataXX(ThinShrink == 1);
Data = [DataXX DataXY DataYY];
% ========================
% statistiek Rxx, Rxy, Ryy
% ========================
MeanData = mean(Data);
CovData = cov(Data);
SData = (diag(CovData)).^(1/2);
CorrData = CovData ./ (SData*SData');


% ======
% output
% ======
figure(statsreport);
H = guihandles(gcf);
axes(H.XXAxes);
hist(DataXX,100);
set(H.XXText,'string',num2str(sqrt(CovData(1,1))));

axes(H.XYAxes);
hist(DataXY,100);
set(H.XYText,'string',num2str(sqrt(CovData(2,2))));

axes(H.YYAxes);
hist(DataYY,100);
set(H.YYText,'string',num2str(sqrt(CovData(3,3))));

axes(H.CovAxes);
image(makeimage(CovData,Stats.C.N));
axes(H.CorrAxes);
image((CorrData+1)*Stats.C.N/2);%1 moet wit zijn, -1 zwart, nuttig omdat corr genormaliseerd is
colormap(Stats.C.Data);



% ====================================================================================
% Opstellen van de covariantie matrix van Rxx in een venster w en de gemiddelde matrix
% ====================================================================================
CovData = gathercov(Stats.Global.Description.Deriv(:,:,5),Stats.Global.Description.Thin,Stats.Global.Description.CovSize);
Stats.Global.Description.RMean = reshape(mean(CovData), 2*Stats.Global.Description.CovSize+1, 2*Stats.Global.Description.CovSize+1)';
axes(H.RMeanAxes);
image(makeimage(Stats.Global.Description.RMean, Stats.C.N));

Stats.Global.Description.RCov = cov(CovData);
axes(H.RCovAxes);
image(makeimage(Stats.Global.Description.RCov, Stats.C.N));
set(gca,'YDir','reverse');fit;
axis(gca,'off');
% ==================================
% Opstellen van de covariantielengte
% ==================================
[Rows Cols] = size(Stats.Global.Description.RCov);
Stats.Global.Description.RCovLength = (reshape(Stats.Global.Description.RCov(:,floor(((Stats.Global.Description.CovSize*2+1)^2+1)/2)),...
            Stats.Global.Description.CovSize*2+1,Stats.Global.Description.CovSize*2+1))';
axes(H.RCovLengthAxes);
image(makeimage(Stats.Global.Description.RCovLength, Stats.C.N));
set(gca,'YDir','reverse');fit;
axis(gca,'off');
% ==================================
% Opstellen van de correlatie matrix
% ==================================
D = diag(Stats.Global.Description.RCov).^(1/2);
Stats.Global.Description.RCorr = Stats.Global.Description.RCov ./ (D * D');
axes(H.RCorrAxes);
image(makeimage(Stats.Global.Description.RCorr, Stats.C.N));
set(gca,'YDir','reverse');fit;
axis(gca,'off');
% =================================
% Opstellen van de correlatielengte
% =================================
% 2*CovSize + 1 is de venstergrootte
[Rows Cols] = size(Stats.Global.Description.RCorr);
Stats.Global.Description.RCorrLength = (reshape(Stats.Global.Description.RCorr(:,floor(((Stats.Global.Description.CovSize*2+1)^2+1)/2)),...
            Stats.Global.Description.CovSize*2+1,Stats.Global.Description.CovSize*2+1))';
axes(H.RCorrLengthAxes);
image(makeimage(Stats.Global.Description.RCorrLength, Stats.C.N));
set(gca,'YDir','reverse');fit;
axis(gca,'off');

% ===================================================================
% Opstellen van de covariantieinformatie nodig voor de segmentanalyse
% ===================================================================
Stats.Global.Description.SegRCov = Stats.Global.Description.RCov(Stats.Global.Description.CovSize+1:Stats.Global.Description.CovSize*2+1:(Stats.Global.Description.CovSize*2+1)^2,...
                                                                 Stats.Global.Description.CovSize+1:Stats.Global.Description.CovSize*2+1:(Stats.Global.Description.CovSize*2+1)^2);
axes(H.RMeanAxes);%OPGELET, info in dezelfde assen geplot!!!
image(makeimage(Stats.Global.Description.SegRCov, Stats.C.N)); 

% ==================
% Segmentmodellering
% ==================
Stats.Global.Description.P = mvnp([Stats.Global.Detection.Threshold - MeanData(1,1) 1], Stats.Global.Description.SegRCov(1));
Stats.Global.Description.SLPD = slpd6(Stats.Global.Detection.Threshold - MeanData(1,1), Stats.Global.Description.SegRCov);


% =======
% Output2
% =======
set(H.DescriptionText, 'TooltipString','Statistics',...
       'Style','text',...
       'visible','on',...
       'Units','normalized',...
       'BackGroundColor',[0.38 0.47 0.70]);
%om text af te drukken met enters tussen wordt het onderverdeeld in
%verschillende delen van een cell-structuur
StatsText{1} = ['P: ',num2str(Stats.Global.Description.P)];
StatsText{2} = ['TP: ',num2str((Stats.Global.FN+Stats.Global.TP)*Stats.Global.Description.P)];
StatsText{4} = ['<SegLengte>: ',num2str(Stats.Global.Description.SLPD*(1:length(Stats.Global.Description.SLPD))'/sum(Stats.Global.Description.SLPD))];
set(H.DescriptionText,'string',StatsText);

axes(H.Axes2)
set(gca,'Nextplot','add');

L = locatemax(Stats.Global.Description.SLPD);
plot(Stats.Global.Description.SLPD(1:length(Stats.Global.Description.SLPD)) / Stats.Global.Description.SLPD(L(1),L(2)));

% --- Executes on button press in ShowLocalRoadPushbutton.
function ShowLocalRoadPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ShowLocalRoadPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats
addim(Stats.Local.Description.Road*Stats.C.N*2);


% --- Executes on button press in ShowEigenPushbutton.
function ShowEigenPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ShowEigenPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats
L = locatemax(Stats.Global.Detection.GrayHessMask);
Stretch = Stats.C.N / Stats.Global.Detection.GrayHessMask(L(1),L(2));
addim(Stats.Global.Detection.GrayHessMask*Stretch);


% --- Executes on button press in DetectionLocStatsPushbutton.
function DetectionLocStatsPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to DetectionLocStatsPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats

% ==================
% calculate segments
% ==================
Stats.Local.Detection.Mask = Stats.Local.Detection.OverviewMask & Stats.Local.Description.Thin;
Stats.Local.Detection.Mask = bwlabeln(Stats.Local.Detection.Mask,8); %meestal sneller dan bwlabel!
L = locatemax(Stats.Local.Detection.Mask);
Stats.Local.Detection.NumOfSeg = Stats.Local.Detection.Mask(L(1), L(2));

% =======================================================
% calculate average segmentlength and length distribution
% =======================================================
Stats.Local.Detection.DistOfSegLengths = 0;
for Seg = 1:Stats.Local.Detection.NumOfSeg
    Lengte = sum(sum(Stats.Local.Detection.Mask == Seg));
        if length(Stats.Local.Detection.DistOfSegLengths) < Lengte
            Stats.Local.Detection.DistOfSegLengths(Lengte) =  1;
        else
            Stats.Local.Detection.DistOfSegLengths(Lengte) = Stats.Local.Detection.DistOfSegLengths(Lengte) + 1;
        end;
end
MaxLength = length(Stats.Local.Detection.DistOfSegLengths);%overload
LengthVec = 1:MaxLength;
if sum(Stats.Local.Detection.DistOfSegLengths) == 0 Stats.Local.Detection.DistOfSegLengths(1) = 1;end;
Stats.Local.Detection.AvgOfSegLengths = Stats.Local.Detection.DistOfSegLengths * LengthVec' / sum(Stats.Local.Detection.DistOfSegLengths);
TP = sum(sum(Stats.Local.Detection.Mask ~= 0)); % true positives
Stats.Local.FN = sum(sum(Stats.Local.Description.Thin)) - TP; %%%%%!!!!!!!!RANDEN ZIJN MEEGEREKEND!!!!!!%%%%%%%%%
Stats.Local.TP =  TP;

% ==================================================
% de gemeten distributie van de grootste eigenwaarde
% ==================================================
% randen mogen niet mee in de statistiek verwerkt worden
ThinShrink = Stats.Local.Description.Thin;
ThinShrink(1:2*Stats.Local.Description.CovSize+1,:) = 0;
ThinShrink(:,1:2*Stats.Local.Description.CovSize+1) = 0;
ThinShrink(size(ThinShrink,1)-2*Stats.Local.Description.CovSize:size(ThinShrink,1),:) = 0;
ThinShrink(:,size(ThinShrink,2)-2*Stats.Local.Description.CovSize:size(ThinShrink,2)) = 0;
EigData = Stats.Local.Detection.GrayHessMask(ThinShrink);



% =====================
% print info to display
% =====================
figure(statsreport);
H = guihandles(gcf);
set(H.DetectionStats, 'TooltipString','Statistics',...
       'Style','text',...
       'visible','on',...
       'Units','normalized',...
       'BackGroundColor',[0.38 0.47 0.70]);
%om text af te drukken met enters tussen wordt het onderverdeeld in
%verschillende delen van een cell-structuur
StatsText{1} = ['#Seg: ',num2str(Stats.Local.Detection.NumOfSeg)];
StatsText{2} = ['FN: ',num2str(Stats.Local.FN)];
StatsText{3} = ['TP: ',num2str(Stats.Local.TP)];
StatsText{4} = ['<SegLengte>: ',num2str(Stats.Local.Detection.AvgOfSegLengths)];
set(H.DetectionStats,'string',StatsText);

axes(H.Axes2);
set(gca,'nextplot','add');
bar(Stats.Local.Detection.DistOfSegLengths);

axes(H.Axes1);   
%segcomb(Stats.Local.FN + Stats.Local.TP, Stats.Local.FN);
axes(H.Axes3);
hist(EigData, 100);
set(H.VarText,'String',num2str(std(EigData)));
colormap(Stats.C.Data);


% --- Executes on button press in ShowLocDetectionPushbutton.
function ShowLocDetectionPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ShowLocDetectionPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats

addim((Stats.Local.Detection.OverviewMask&Stats.Local.Description.Thin)*Stats.C.N*3);


% --- Executes on button press in ShowDetectionPushbutton.
function ShowDetectionPushbutton_Callback(hObject, eventdata, handles)
% hObject    handle to ShowDetectionPushbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Stats

addim((Stats.Global.Detection.OverviewMask&Stats.Global.Description.Thin)*Stats.C.N*3);



function [TP_Det, TP_Des, Segavg_Det, Segavg_Des, NumOfSeg] = getstats_inchess
global Stats Scene

% ==========================================================
% Verzamelen van de blijvende informatie voor de description
% ==========================================================
% randen mogen niet mee in de statistiek verwerkt worden
ThinShrink = Stats.Global.Description.Thin;
ThinShrink(1:2*Stats.Global.Description.CovSize+1,:) = 0;
ThinShrink(:,1:2*Stats.Global.Description.CovSize+1) = 0;
ThinShrink(size(ThinShrink,1)-2*Stats.Global.Description.CovSize:size(ThinShrink,1),:) = 0;
ThinShrink(:,size(ThinShrink,2)-2*Stats.Global.Description.CovSize:size(ThinShrink,2)) = 0;
% getallen extraheren
DataYY = Stats.Global.Description.Deriv(:,:,3);
DataYY = DataYY(ThinShrink == 1);
DataXY = Stats.Global.Description.Deriv(:,:,4);
DataXY = DataXY(ThinShrink == 1);
DataXX = Stats.Global.Description.Deriv(:,:,5);
DataXX = DataXX(ThinShrink == 1);
Data = [DataXX DataXY DataYY];
% statistiek Rxx
MeanData = mean(Data);% is de gemiddelde waarde in de distributie van Rxx
CovData = gathercov(Stats.Global.Description.Deriv(:,:,5),Stats.Global.Description.Thin,Stats.Global.Description.CovSize);
Stats.Global.Description.RMean = reshape(mean(CovData), 2*Stats.Global.Description.CovSize+1, 2*Stats.Global.Description.CovSize+1)';
Stats.Global.Description.RCov = cov(CovData);
Stats.Global.Description.SegRCov = Stats.Global.Description.RCov(Stats.Global.Description.CovSize+1:Stats.Global.Description.CovSize*2+1:(Stats.Global.Description.CovSize*2+1)^2,...
                                                                 Stats.Global.Description.CovSize+1:Stats.Global.Description.CovSize*2+1:(Stats.Global.Description.CovSize*2+1)^2);
% ========================================================
% Verzamelen van de blijvende informatie voor de detection
% ========================================================
figure(overview);
H = guihandles(overview);
Max = get(H.HessUpSlider,'Max');
Min = get(H.HessUpSlider,'Min');
X = get(H.Mask,'XLim');
Y = get(H.Mask,'YLim');

% =========
% simulatie
% =========
Steps = 10;
for i = 1:Steps
    %status report
    i
    tic
    %overview
    %Step = Min + 2*(Max - Min)/3 + (Max-Min)/3 /Steps*i;
    Step = Max/Steps*i;
    Scene.Mask = resetmask(Scene.Input.I);
    Scene.Hess.UpLim = Step;%NOT ABSOLUTE!!!
    calchessmask('upper');
    addhessupmask;
    
    %overview to stats interface
    Stats.Global.Detection.OverviewMask = logical(Scene.Mask(Y(1):Y(2),X(1):X(2)));
    Stats.Global.Detection.Threshold = Scene.Hess.UpLim;
    
    %stats description
    P = mvnp([Stats.Global.Detection.Threshold - MeanData(1,1) 1], Stats.Global.Description.SegRCov(1));
    SLPD = slpd6(Stats.Global.Detection.Threshold - MeanData(1,1), Stats.Global.Description.SegRCov);
    %NSLPD = slpd7(Stats.Global.Detection.Threshold - MeanData(1,1), Stats.Global.Description.SegRCov);
    
    i
    %stats detection
        % calculate segments
    Stats.Global.Detection.Mask = Stats.Global.Detection.OverviewMask & Stats.Global.Description.Thin;
    Stats.Global.Detection.Mask = bwlabeln(Stats.Global.Detection.Mask,8); %meestal sneller dan bwlabel!
    L = locatemax(Stats.Global.Detection.Mask);
    Stats.Global.Detection.NumOfSeg = Stats.Global.Detection.Mask(L(1), L(2));
        % calculate average segmentlength and length distribution
    Stats.Global.Detection.DistOfSegLengths = 0;
    for Seg = 1:Stats.Global.Detection.NumOfSeg
        Lengte = sum(sum(Stats.Global.Detection.Mask == Seg));
        if length(Stats.Global.Detection.DistOfSegLengths) < Lengte
            Stats.Global.Detection.DistOfSegLengths(Lengte) =  1;
        else
            Stats.Global.Detection.DistOfSegLengths(Lengte) = Stats.Global.Detection.DistOfSegLengths(Lengte) + 1;
        end;
    end
    MaxLength = length(Stats.Global.Detection.DistOfSegLengths);%overload
    LengthVec = 1:MaxLength;
    DoSL_sum = sum(Stats.Global.Detection.DistOfSegLengths);
    if DoSL_sum
        Stats.Global.Detection.AvgOfSegLengths = Stats.Global.Detection.DistOfSegLengths * LengthVec' / DoSL_sum;
    else
        Stats.Global.Detection.AvgOfSegLengths = 0;
    end;
    TP = sum(sum(Stats.Global.Detection.Mask ~= 0)); % true positives
    
    %output opslaan
    NoOfPos = sum(sum(Stats.Global.Description.Thin));
    TP_Det(i) = TP;
    TP_Des(i) = NoOfPos*P;
    NumOfSeg(i) = Stats.Global.Detection.NumOfSeg;

    %NInt = sum(floor(NSLPD ./ (1:length(NSLPD)) * (NoOfPos*(1-P) / sum(NSLPD)))); 
    %if NInt < 1 NInt = 1;end;
        
    Segavg_Det(i) = Stats.Global.Detection.AvgOfSegLengths;
    SLPD_sum = sum(SLPD);
    if SLPD_sum
        Segavg_Des(i) = SLPD*(1:length(SLPD))'/sum(SLPD);
    else
        Segavg_Des(i) = NoOfPos;
    end;
    %Segavg_Des_inv(i) = round(NoOfPos/NInt);    
    
    %status report
    toc
end;