function replaceobj(H, G);
% deze functie vervangt het bestaand object H door een ander bestaand
% object G van hetzelfde type
% alle parameters en children van G worden meegenomen, enkel de positie van
% H in zijn parent wordt behouden

% =================================
% deletes every existing child of H
% =================================
% Child = get(H,'children');
% delete(Child);
% 
% ==================================
% copies settings from parent G to H
% ==================================
Settings = get(G);
Settings = rmfield(Settings,'Position');
Settings = rmfield(Settings,'BeingDeleted');
Settings = rmfield(Settings,'Children');
Settings = rmfield(Settings,'Parent');
Settings = rmfield(Settings,'CurrentPoint');
% de text handles die je probeert te koppelen aan een titel moeten reeds
% als parent een assenstel hebben, of het set commando zal een foutmelding
% geven, vandaar dat ze hier verwijderd worden, omdat ze soms ingevoerd
% worden als gewoon text in de annotation layer, dat geeft problemen
Settings = rmfield(Settings,'Title');
Settings = rmfield(Settings,'Type');
Settings = rmfield(Settings,'XLabel');
Settings = rmfield(Settings,'YLabel');
Settings = rmfield(Settings,'ZLabel');
set(H,Settings);


% =======================
% copies all the children
% =======================
Child = get(G,'children')

if strcmp(class(Child),'cell')
    for i = 1:length(Child)
        copyobj(Child{i}, H);
    end
else
    copyobj(Child, H);
end